
import { _decorator, Sprite, Node, Component, EventTouch, UITransform, Color, Vec3, Collider, Texture2D, ImageAsset, RenderTexture, Layers, SpriteFrame, Vec2, Camera, view, __private } from 'cc';
import RenderUtil from '../../common/scripts/global/RenderUtil';
const { ccclass, property } = _decorator;


@ccclass('ClickTest')
export class ClickTest extends Component {


    private clickLevelMap(evt: EventTouch, id) {
        const img: Sprite = evt.target.getComponent(Sprite);
        if (img) {
            const TargetNode: Node = this.node;
            const nodeUit = TargetNode.getComponent(UITransform);

            // 点击位置
            const touchPos = evt.getLocation();
            const localPos = nodeUit.convertToNodeSpaceAR(new Vec3(touchPos.x, touchPos.y));

            // 获取像素数据
            const pixelsData = RenderUtil.readPixels(img.spriteFrame.texture);
            // const pixelsData2 = RenderUtil.getPixelsData(TargetNode);

            console.log("---获取像素数据-pixelsData--------", pixelsData.length / 4, pixelsData)
            // console.log("---获取像素数据-pixelsData2---2-----", pixelsData2.length / 4, pixelsData2)

            // 截取像素颜色
            let x = localPos.x + nodeUit.anchorX * nodeUit.width,
                y = -(localPos.y - nodeUit.anchorY * nodeUit.height);
            console.log("---点击坐标-转换--xy------", x, ", ", y)

            const index = (nodeUit.width * 4 * Math.floor(y)) + (4 * Math.floor(x));

            console.log("---点击坐标-转换--index------", index)

            const colorsData = pixelsData.slice(index, index + 4);

            // 当前点击像素颜色
            const color = new Color(colorsData[0], colorsData[1], colorsData[2]);
            const opacity = colorsData[3];

            console.log("----截取像素颜色---4----------colorsData--------", colorsData)
            console.log("----截取像素颜色---3----------opacity--------", opacity, color)

        }
    }



}